<?php
/* Autor...:  */
/* Esquema.: SR_DevolucionDetCorte.xml */
/* Generado: 2021-06-25 07:20:20 */

/* Metodos de acceso a los campos de la tabla SR_DevolucionDetCorte */
abstract class BaseSR_DevolucionDetCorteBN
{
    /* Campos de la tabla */
    private $i_DevolDetCorteId;    // DevolDetCorteId: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $i_IdProyecto;    // IdProyecto: ( no definido )
    private $s_EstadoDevolucionId;    // EstadoDevolucionId: ( no definido )
    private $s_GrupoId;    // GrupoId: ( no definido )
    private $d_FechaIni;    // FechaIni: ( no definido )
    private $s_Tipo;    // Tipo: ( no definido )
    private $s_EstadoDesc;    // EstadoDesc: ( no definido )
    private $s_Comentario;    // Comentario: ( no definido )
    private $s_Documento;    // Documento: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $s_DescripcionItem;    // DescripcionItem: ( no definido )
    private $f_Cantidad;    // Cantidad: ( no definido )
    private $d_FechaFin;    // FechaFin: ( no definido )
    private $d_FechaCorte;    // FechaCorte: ( no definido )
    private $i_Dias;    // Dias: ( no definido )
    private $f_PrecioUnitario;    // PrecioUnitario: ( no definido )
    private $f_MontoTotal;    // MontoTotal: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )

    /* Establece el valor del campo DevolDetCorteId */
    public function setDevolDetCorteId( $i_DevolDetCorteId )
    {
        $this->i_DevolDetCorteId = $i_DevolDetCorteId;
    }

    /* Obtiene el valor del campo DevolDetCorteId */
    public function getDevolDetCorteId()
    {
        return $this->i_DevolDetCorteId;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdProyecto */
    public function setIdProyecto( $i_IdProyecto )
    {
        $this->i_IdProyecto = $i_IdProyecto;
    }

    /* Obtiene el valor del campo IdProyecto */
    public function getIdProyecto()
    {
        return $this->i_IdProyecto;
    }

    /* Establece el valor del campo EstadoDevolucionId */
    public function setEstadoDevolucionId( $s_EstadoDevolucionId )
    {
        $this->s_EstadoDevolucionId = $s_EstadoDevolucionId;
    }

    /* Obtiene el valor del campo EstadoDevolucionId */
    public function getEstadoDevolucionId()
    {
        return $this->s_EstadoDevolucionId;
    }

    /* Establece el valor del campo GrupoId */
    public function setGrupoId( $s_GrupoId )
    {
        $this->s_GrupoId = $s_GrupoId;
    }

    /* Obtiene el valor del campo GrupoId */
    public function getGrupoId()
    {
        return $this->s_GrupoId;
    }

    /* Establece el valor del campo FechaIni */
    public function setFechaIni( $d_FechaIni )
    {
        $this->d_FechaIni = $d_FechaIni;
    }

    /* Obtiene el valor del campo FechaIni */
    public function getFechaIni()
    {
        return $this->d_FechaIni;
    }

    /* Establece el valor del campo Tipo */
    public function setTipo( $s_Tipo )
    {
        $this->s_Tipo = $s_Tipo;
    }

    /* Obtiene el valor del campo Tipo */
    public function getTipo()
    {
        return $this->s_Tipo;
    }

    /* Establece el valor del campo EstadoDesc */
    public function setEstadoDesc( $s_EstadoDesc )
    {
        $this->s_EstadoDesc = $s_EstadoDesc;
    }

    /* Obtiene el valor del campo EstadoDesc */
    public function getEstadoDesc()
    {
        return $this->s_EstadoDesc;
    }

    /* Establece el valor del campo Comentario */
    public function setComentario( $s_Comentario )
    {
        $this->s_Comentario = $s_Comentario;
    }

    /* Obtiene el valor del campo Comentario */
    public function getComentario()
    {
        return $this->s_Comentario;
    }

    /* Establece el valor del campo Documento */
    public function setDocumento( $s_Documento )
    {
        $this->s_Documento = $s_Documento;
    }

    /* Obtiene el valor del campo Documento */
    public function getDocumento()
    {
        return $this->s_Documento;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo DescripcionItem */
    public function setDescripcionItem( $s_DescripcionItem )
    {
        $this->s_DescripcionItem = $s_DescripcionItem;
    }

    /* Obtiene el valor del campo DescripcionItem */
    public function getDescripcionItem()
    {
        return $this->s_DescripcionItem;
    }

    /* Establece el valor del campo Cantidad */
    public function setCantidad( $f_Cantidad )
    {
        $this->f_Cantidad = $f_Cantidad;
    }

    /* Obtiene el valor del campo Cantidad */
    public function getCantidad()
    {
        return $this->f_Cantidad;
    }

    /* Establece el valor del campo FechaFin */
    public function setFechaFin( $d_FechaFin )
    {
        $this->d_FechaFin = $d_FechaFin;
    }

    /* Obtiene el valor del campo FechaFin */
    public function getFechaFin()
    {
        return $this->d_FechaFin;
    }

    /* Establece el valor del campo FechaCorte */
    public function setFechaCorte( $d_FechaCorte )
    {
        $this->d_FechaCorte = $d_FechaCorte;
    }

    /* Obtiene el valor del campo FechaCorte */
    public function getFechaCorte()
    {
        return $this->d_FechaCorte;
    }

    /* Establece el valor del campo Dias */
    public function setDias( $i_Dias )
    {
        $this->i_Dias = $i_Dias;
    }

    /* Obtiene el valor del campo Dias */
    public function getDias()
    {
        return $this->i_Dias;
    }

    /* Establece el valor del campo PrecioUnitario */
    public function setPrecioUnitario( $f_PrecioUnitario )
    {
        $this->f_PrecioUnitario = $f_PrecioUnitario;
    }

    /* Obtiene el valor del campo PrecioUnitario */
    public function getPrecioUnitario()
    {
        return $this->f_PrecioUnitario;
    }

    /* Establece el valor del campo MontoTotal */
    public function setMontoTotal( $f_MontoTotal )
    {
        $this->f_MontoTotal = $f_MontoTotal;
    }

    /* Obtiene el valor del campo MontoTotal */
    public function getMontoTotal()
    {
        return $this->f_MontoTotal;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'DevolDetCorteId' => $this->getDevolDetCorteId(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdProyecto' => $this->getIdProyecto(),
            'EstadoDevolucionId' => $this->getEstadoDevolucionId(),
            'GrupoId' => $this->getGrupoId(),
            'FechaIni' => $this->getFechaIni(),
            'Tipo' => $this->getTipo(),
            'EstadoDesc' => $this->getEstadoDesc(),
            'Comentario' => $this->getComentario(),
            'Documento' => $this->getDocumento(),
            'IdItem' => $this->getIdItem(),
            'DescripcionItem' => $this->getDescripcionItem(),
            'Cantidad' => $this->getCantidad(),
            'FechaFin' => $this->getFechaFin(),
            'FechaCorte' => $this->getFechaCorte(),
            'Dias' => $this->getDias(),
            'PrecioUnitario' => $this->getPrecioUnitario(),
            'MontoTotal' => $this->getMontoTotal(),
            'Estado' => $this->getEstado(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SR_DevolucionDetCorteBN desde un RecordSet */
    public static function retrieveByRs( $o_SR_DevolucionDetCorteRs )
    {
        $o_SR_DevolucionDetCorteBN = new SR_DevolucionDetCorteBN();
        $o_SR_DevolucionDetCorteBN->setDevolDetCorteId( ( integer ) $o_SR_DevolucionDetCorteRs[ "DevolDetCorteId" ] );
        $o_SR_DevolucionDetCorteBN->setIdCompania( ( integer ) $o_SR_DevolucionDetCorteRs[ "IdCompania" ] );
        $o_SR_DevolucionDetCorteBN->setIdSucursal( ( integer ) $o_SR_DevolucionDetCorteRs[ "IdSucursal" ] );
        $o_SR_DevolucionDetCorteBN->setIdProyecto( ( integer ) $o_SR_DevolucionDetCorteRs[ "IdProyecto" ] );
        $o_SR_DevolucionDetCorteBN->setEstadoDevolucionId( $o_SR_DevolucionDetCorteRs[ "EstadoDevolucionId" ] );
        $o_SR_DevolucionDetCorteBN->setGrupoId( $o_SR_DevolucionDetCorteRs[ "GrupoId" ] );
        $o_SR_DevolucionDetCorteBN->setFechaIni( utilTimestamp::getTimestamp( $o_SR_DevolucionDetCorteRs[ "FechaIni" ], "Y-m-d" ) );
        $o_SR_DevolucionDetCorteBN->setTipo( $o_SR_DevolucionDetCorteRs[ "Tipo" ] );
        $o_SR_DevolucionDetCorteBN->setEstadoDesc( $o_SR_DevolucionDetCorteRs[ "EstadoDesc" ] );
        $o_SR_DevolucionDetCorteBN->setComentario( $o_SR_DevolucionDetCorteRs[ "Comentario" ] );
        $o_SR_DevolucionDetCorteBN->setDocumento( $o_SR_DevolucionDetCorteRs[ "Documento" ] );
        $o_SR_DevolucionDetCorteBN->setIdItem( $o_SR_DevolucionDetCorteRs[ "IdItem" ] );
        $o_SR_DevolucionDetCorteBN->setDescripcionItem( $o_SR_DevolucionDetCorteRs[ "DescripcionItem" ] );
        $o_SR_DevolucionDetCorteBN->setCantidad( ( float ) $o_SR_DevolucionDetCorteRs[ "Cantidad" ] );
        $o_SR_DevolucionDetCorteBN->setFechaFin( utilTimestamp::getTimestamp( $o_SR_DevolucionDetCorteRs[ "FechaFin" ], "Y-m-d" ) );
        $o_SR_DevolucionDetCorteBN->setFechaCorte( utilTimestamp::getTimestamp( $o_SR_DevolucionDetCorteRs[ "FechaCorte" ], "Y-m-d" ) );
        $o_SR_DevolucionDetCorteBN->setDias( ( integer ) $o_SR_DevolucionDetCorteRs[ "Dias" ] );
        $o_SR_DevolucionDetCorteBN->setPrecioUnitario( ( float ) $o_SR_DevolucionDetCorteRs[ "PrecioUnitario" ] );
        $o_SR_DevolucionDetCorteBN->setMontoTotal( ( float ) $o_SR_DevolucionDetCorteRs[ "MontoTotal" ] );
        $o_SR_DevolucionDetCorteBN->setEstado( $o_SR_DevolucionDetCorteRs[ "Estado" ] );
        $o_SR_DevolucionDetCorteBN->setUsuarioCreacion( $o_SR_DevolucionDetCorteRs[ "UsuarioCreacion" ] );
        $o_SR_DevolucionDetCorteBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SR_DevolucionDetCorteRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SR_DevolucionDetCorteBN->setUsuarioModificacion( $o_SR_DevolucionDetCorteRs[ "UsuarioModificacion" ] );
        $o_SR_DevolucionDetCorteBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SR_DevolucionDetCorteRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        return $o_SR_DevolucionDetCorteBN;
    }
}
?>